<template>
  <div>
    <q-table
      title="Daftar Produk"
      class="table-produk-saya"
      :data="data"
      :columns="columns"
      row-key="id"
      :pagination.sync="pagination"
      :loading="loading"
      :filter="filter"
      @request="onRequest"
      binary-state-sort
    >
      <template v-slot:top-right style="color: white !important;">
        <q-input borderless dense debounce="300" v-model="filter" placeholder="Cari Produk" @input="onRequest" color="white">
          <template v-slot:append style="color: white">
            <q-icon name="search"  />
          </template>
        </q-input>
      </template>

      <template v-slot:body="props">
        <q-tr :props="props" :key="`m_${props.row.index}`">
          <q-td
            style="width: 30px"
            key="index"
            :props="props"
          >
            {{ props.row.index }}.
          </q-td>
          <q-td key="main_image" :props="props" >
            <q-img :src="props.row.main_image" style="max-width: 100px" @click="showImage(props.row.main_image)"/>
          </q-td>
          <q-td style="width: 150px" key="name_product" :props="props" >{{ props.row.name_product }}</q-td>
          <q-td style="width: 150px" key="product_type" :props="props" >{{ (props.row.product_type) ? props.row.product_type.product_type
            : "Jenis Produk Tidak ditemukan" }}</q-td>
          <q-td style="width: 150px" key="product_category" :props="props" >{{ (props.row.product_category) ? props.row.product_category.category :
            "Kategori Produk Tidak Ditemukan"
            }}</q-td>

          <q-td key="price" :props="props" >{{ props.row.price | currency }}</q-td>
          <q-td key="status" :props="props">
            <p style="padding-top: 15px" v-if="props.row.status == 0">Draft</p>
            <p style="padding-top: 15px" v-if="props.row.status == 1">Published</p>
            <p style="padding-top: 15px" v-if="props.row.status == 2">Unpublished</p>
            <p style="padding-top: 15px" v-if="props.row.status == 3">Diperiksa</p>
            <p style="padding-top: 15px" v-if="props.row.status == 4">Disetujui</p>
            <p style="padding-top: 15px" v-if="props.row.status == 5">Publish</p>
            <p style="padding-top: 15px" v-if="props.row.status == 6">Unpublish</p>
            <p style="padding-top: 15px" v-if="props.row.status == 7">Arsip</p>
            <p style="padding-top: 15px" v-if="props.row.status == 8">Ditolak</p>
          </q-td>

          <q-td key="actions" :props="props" style="padding-left: 0; padding-right: 0">
            <q-btn style="margin-right: 5px" size="10px" color="primary" v-if="props.row.status == 0">Detail</q-btn>
            <q-btn style="margin-right: 5px" size="10px" color="orange" >Edit</q-btn>
            <q-btn style="margin-right: 5px" size="10px" color="red" type="a" :to="`/produk/hapus/${props.row.id}`"  >Hapus</q-btn>
            <q-btn style="margin-right: 5px" size="10px" color="green" v-if="props.row.status == 4 || props.row.status == 6" type="a" :to="`/publish/${props.row.id}`">Publish</q-btn>
            <q-btn style="margin-right: 5px" size="10px" color="blue"
                   v-if="props.row.status == 5" type="a" :to="`/unpublish/${props.row.id}`" >Unpublish</q-btn>
          </q-td>
        </q-tr>
      </template>
    </q-table>
  </div>
</template>

<script>
  export default {
    data () {
      return {
        filter: '',
        loading: false,
        token: localStorage.getItem("token"),
        pagination: {
          sortBy: 'index',
          descending: true,
          page: 1,
          rowsPerPage: 5,
          rowsNumber: 10
        },
        columns: [
          {
            name: 'index',
            required: true,
            label: 'No',
            align: 'left',
            field: 'index',
            format: val => `${val}`,
            sortable: true
          },
          { name: 'main_image', align: 'center', label: 'Gambar Utama', field: 'main_image', sortable: true },
          { name: 'name_product', align: 'center', label: 'Nama Produk', field: 'name_product', sortable: true },
          { name: 'product_type', align: 'center', label: 'Jenis Produk', field: 'product_type',
            sortable: true},
          { name: 'product_category', align: 'center', label: 'Kategori', field: 'product_category',
            sortable: true },
          { name: 'price', align: 'center', label: 'Harga', field: 'price', sortable: true },
          { name: 'status', align: 'center', label: 'Status', field: 'status', sortable: true },
          { name: 'actions', align: 'center', label: 'Aksi', field: 'status', sortable: true },
        ],
        data: [],
      }
    },

    filters: {
      currency(price) {
        return new Intl.NumberFormat("id-ID", {
          style: "currency",
          currency: "IDR",
          minimumFractionDigits: 2
        }).format(price);
      }
    },

    mounted () {
      // get initial data from server (1st page)
      this.onRequest({
        pagination: this.pagination,
        filter: undefined
      })
    },
    methods: {
      hapusProduct: function (id) {
        alert(id)
      },

      showImage(val) {
        this.$q.dialog({
          message: `<img src="${val}" style="width: 100%" />`,
          html: true,
        })
      },
      onRequest (props) {
        console.log("props", props);

        const { descending, page, rowsNumber, rowsPerPage, sortBy } = props.pagination;
        const filter = props.filter

        if (! descending) {
          this.pagination.descending = true
        }

        this.loading = true
        let apiUrl =
          `api/product/list?page=${page}&perPage=${rowsPerPage}&sortBy=${sortBy}&filter=${filter}&descending=${descending}`

        let config = {
          method: "get",
          url: apiUrl ,
          headers: {
            Authorization: "Bearer " + this.token
          }
        }

        this.$axios(config)
          .then(response => {

            let data = response.data

            this.data = data.data

            this.data.forEach((row, index) => {
              row.index = index + 1 + ((page-1)*rowsPerPage)
            })

            this.pagination = {
              sortBy: 'index',
              descending: descending,
              page: data.current_page,
              rowsPerPage: data.per_page,
              rowsNumber: data.total
            }

          })
          .catch(error => {
            console.log(error)
          })
          .then(always => {
            this.loading = false
          })
      },
    }
  }
</script>

<style lang="sass" scoped>
  .q-table--no-wrap td
    white-space: normal

    .table-produk-saya

      .q-table__top,
      .q-table__bottom,
      thead tr:first-child th
        /* bg color is important for th; just specify one */
        background-color: #009688
        color: white
        font-size: 16px

      thead tr th
        position: sticky
        z-index: 1
      thead tr:first-child th
        top: 0

      /* this is when the loading indicator appears */
      &.q-table--loading thead tr:last-child th
        /* height of all previous header rows */
        top: 48px
</style>

